# https://github.com/piotrmurach/tty-prompt

require 'thor'
require 'tty-prompt'
require 'tty-file'
require 'tty-spinner'

module Dx

  class CLI < Thor

    include Thor::Actions

    def self.source_root
      File.dirname(__FILE__) + '/../'
    end

    desc "Login", "Login to application"
    def login

      # USER PROMPT
      prompt    = TTY::Prompt.new(interrupt: :exit)
      email     = prompt.ask('Email :', required: true) do |q|
        q.validate(:email, 'Invalid email address')
      end
      password  = prompt.mask('Password :', required: true) do |q|
        q.validate(/^.{8,}$/, 'Password is too short')
      end
      
      # Verification
      if email && password
        Deemx::Auth.login(email,password) ? \
          prompt.ok('You are now logged in!') : \
          prompt.error('Invalid credentials')
      else
        prompt.say('Bye.')
      end

    end

    desc 'Start folder', 'Copy selected folder'
    def init(project_name)
      directory "templates/pug", project_name
    end

  end

end